   /*  ஢ ᭮- ॢ쥢. */
   /*                                                    */
   /*  ணࠬ: Niemann Thomas (1998)             */
   /* -------------------------------------------------- */
   #include<stdio.h>
   #include<stdlib.h>
   #include<string.h>
   #include<stdarg.h>
   #define NIL &sentinel       /* ᠭ 쥢 */
   #define compLT(a,b) (a < b)
   #define compEQ(a,b) (a == b)
   /* -------------------------------------------------------- */
      typedef int T;  /*  祭, ࠭  㧫 ॢ */
      /* ----------------------------------------------------- */
      /*            ᠭ ᭮-୮ ॢ             */
      /* ----------------------------------------------------- */
      typedef enum {BLACK,RED} nodeColor;
      typedef struct Node_
      {
        struct Node_ *left;   /*                   */
        struct Node_ *right;  /* ࠢ                 */
        struct Node_ *parent; /* ⥫                  */
	nodeColor color;      /*  㧫 (BLACK,RED)     */
        T data;               /* 祭, ࠭  㧫 */
      } Node;
      Node sentinel={NIL,NIL,0,BLACK,0};
      Node *root=NIL;          /* ७ ᭮-୮ ॢ */
      /* ----------------------------------------------------- */
      void rotateLeft(Node *);
      void rotateRight(Node *);
      void insertFixup(Node *);
      Node *insertNode(T);
      void deleteFixup(Node *);
      void deleteNode (Node *);
      Node *findNode(T);
      void Vyvod(Node *,int);
  /* ---------------------- */
   int main()
   {
     int a;
     struct Node_ *t;
     printf("  塞 㧫: "); scanf("%d",&a);
     while (a)
     {
       insertNode(a);
       printf("\n"); Vyvod(root,0); printf("\n");
       printf("  塞 㧫: "); scanf("%d",&a);
     }
     printf("\n");
     /* --------------------------------------------------- */
     printf("  㤠塞 㧫: "); scanf("%d",&a);
     while (a)
     {
       if ((t=findNode(a))!=NULL)
	 deleteNode(t);
       printf("\n"); Vyvod(root,0); printf("\n");
       printf("  㤠塞 㧫: "); scanf("%d",&a);
     }
     return 0;
   }
  /* --------------------- */
   void rotateLeft (Node *x)
   /*   㧫 x  */
   /* --------------------- */
   /*    x             y    */
   /*   / \           / \   */
   /*  a   y   -->   x   c  */
   /*     / \       / \     */
   /*    b   c     a   b    */
   /* --------------------- */
   {
      Node *y=x->right;
      /* ----------- */
      x->right=y->left;
      if (y->left!=NIL)
        y->left->parent=x;
      if (y!=NIL)
        y->parent=x->parent;
      if (x->parent)
      {
        if (x==x->parent->left)
          x->parent->left=y;
	else x->parent->right=y;
      }
      else root=y;
      y->left=x;
      if (x!=NIL)
        x->parent=y;
   }
  /* ---------------------- */
   void rotateRight (Node *x)
   /* ࠢ  㧫 x  */
   /* ---------------------- */
   /*      x          y      */
   /*     / \        / \     */
   /*    y   c --> a    x    */
   /*   / \            / \   */
   /*  a   b          b   c  */
   /* ---------------------- */
   {
      Node *y=x->left;
      /* ----------- */
      x->left=y->right;
      if (y->right!=NIL)
        y->right->parent=x;
      if (y!=NIL)
	y->parent=x->parent;
      if (x->parent)
      {
        if (x==x->parent->right)
          x->parent->right=y;
	else x->parent->left=y;
      }
      else root=y;
      y->right=x;
      if (x!=NIL)
        x->parent=y;
   }
  /* ---------------------- */
   void insertFixup (Node *x)
   /* ঠ  ᭮-୮ ॢ */
   /* ᫥ 祭 㧫 x                    */
   /* ----------------------------------------- */
   {
      /* ஢ઠ 믮 ᢮ ᭮-୮ ॢ */
      while (x!=root&&x->parent->color==RED)
      {
	if (x->parent==x->parent->parent->left)
	{
	  Node *y=x->parent->parent->right;
	  if (y->color==RED)
	  {
            /* "" 襭  梥 RED */
	    x->parent->color=BLACK;
	    y->color=BLACK;
	    x->parent->parent->color=RED;
	    x=x->parent->parent;
	  }
	  else {
                 /* "" 襭  梥 BLACK */
		 if (x==x->parent->right)
		 {
                   /*  x  뭮 */
                   x=x->parent; rotateLeft(x);
		 }
                 /* ४᪠   */
                 x->parent->color=BLACK;
                 x->parent->parent->color=RED;
                 rotateRight(x->parent->parent);
               }
	}
	else {
               /* "ઠ쭮" ࠦ ।饣  */
               Node *y=x->parent->parent->left;
               if (y->color==RED)
               {
                 /* "" 襭  梥 RED */
                 x->parent->color=BLACK;
                 y->color=BLACK;
                 x->parent->parent->color=RED;
                 x = x->parent->parent;
               }
               else {
                      /* "" 襭  梥 BLACK */
                      if (x==x->parent->left)
                      {
                        x=x->parent; rotateRight(x);
                      }
                      x->parent->color=BLACK;
                      x->parent->parent->color=RED;
                      rotateLeft(x->parent->parent);
                    }
             }
      }
      root->color=BLACK;
   }
  /* --------------------- */
   Node *insertNode (T data)
   /* 祭 㧫 data  ᭮-୮ ॢ */
   /* ------------------------------------------ */
   {
      Node *current,*parent,*x;
      /*   ਪ९  㧫 */
      current=root;
      parent=0;
      while (current!=NIL)
      {
        if (compEQ(data,current->data))
          return current;
	parent=current;
        current=compLT(data,current->data)?
                                      current->left:current->right;
      }
      /* 뤥 ᪮    㧫 */
      if ((x=(Node *)malloc(sizeof(*x)))==0)
      {
        printf ("筮   祭.\n");
        exit(1);
      }
      x->data=data; x->parent=parent;
      x->left=NIL; x->right=NIL; x->color=RED;
      /* ------------------------------------- */
      /* 祭 㧫  ᭮-୮ ॢ */
      /* ------------------------------------- */
      if (parent)
      {
        if (compLT(data,parent->data))
          parent->left=x;
        else parent->right=x;
      }
      else root=x;
      insertFixup(x);
      return x;
   }
  /* ---------------------- */
   void deleteFixup (Node *x)
   /* ঠ  ᭮-୮ ॢ */
   /* ᫥ 㤠 㧫 x                     */
   /* ----------------------------------------- */
   {
      while (x!=root&&x->color==BLACK)
      {
        if (x==x->parent->left)
        {
          Node *w=x->parent->right;
          if (w->color==RED)
          {
            w->color=BLACK; x->parent->color=RED;
            rotateLeft(x->parent);
            w=x->parent->right;
          }
	  if (w->left->color==BLACK && w->right->color==BLACK)
          {
            w->color=RED; x=x->parent;
          }
          else {
                 if (w->right->color==BLACK)
                 {
                   w->left->color=BLACK;
                   w->color=RED;
                   rotateRight(w);
		   w=x->parent->right;
                 }
                 w->color=x->parent->color;
                 x->parent->color=BLACK;
                 w->right->color=BLACK;
                 rotateLeft(x->parent);
                 x=root;
               }
        }
        else {
	       Node *w=x->parent->left;
               if (w->color==RED)
               {
                 w->color=BLACK;
                 x->parent->color=RED;
                 rotateRight(x->parent);
                 w=x->parent->left;
               }
               if (w->right->color==BLACK && w->left->color==BLACK)
               {
		 w->color=RED; x=x->parent;
               }
               else {
                      if (w->left->color==BLACK)
                      {
                        w->right->color=BLACK;
                        w->color=RED;
                        rotateLeft(w);
                        w=x->parent->left;
                      }
		      w->color=x->parent->color;
                      x->parent->color=BLACK;
                      w->left->color=BLACK;
                      rotateRight(x->parent);
                      x=root;
                    }
             }
      }
      x->color=BLACK;
   }
  /* --------------------- */
   void deleteNode (Node *z)
   /*  㧫 z  ᭮-୮ ॢ */
   /* ---------------------------------------- */
   {
      Node *x,*y;
      if (!z||z==NIL)
        return;
      if (z->left==NIL||z->right==NIL)
      {
	/*  y  NIL-㧥  ⢥ 뭠 */
        y=z;
      }
      else {
             /*   ॢ 㧫, 饣 NIL-㧥 */
             /*  ⢥ 뭠                        */
             y=z->right;
             while (y->left!=NIL)
               y=y->left;
           }
      /*  x  ⢥ 뭮 㧫 y */
      if (y->left!=NIL)
        x=y->left;
      else x=y->right;
      /*  y  த⥫᪮ 楯窨 */
      x->parent=y->parent;
      if (y->parent)
        if (y==y->parent->left)
          y->parent->left=x;
        else y->parent->right=x;
      else root=x;
      if (y!=z)
        z->data=y->data;
      if (y->color==BLACK)
        deleteFixup(x);
      free(y);
   }
  /* ------------------ */
   Node *findNode(T data)
   /*  㧫, ᮤঠ饣 祭 data  㧫 */
   /* -------------------------------------------- */
   {
      Node *current=root;
      while(current!=NIL)
        if (compEQ(data, current->data))
          return (current);
        else current=compLT(data,current->data)?
                     current->left:current->right;
      return 0;
   }
  /* ------------------------ */
   void Vyvod(Node *Tree,int l)
   /* ࠦ ᭮-୮ ॢ Tree  ࠭ */
   /* ᯫ (0 - 㧥 , 1 - 㧥 ):     */
   /* ------------------------------------------------ */
   {
      int i;
      if (Tree!=NIL)
      {
	Vyvod(Tree->right,l+1);
	for (i=1;i<=l;i++)
	  printf("   ");
	printf("%d(%d)\n",Tree->data,Tree->color);
	Vyvod(Tree->left,l+1);
      }
   }
